package edu.cs2335.lab7.creature;

import java.io.Serializable;
import java.util.ArrayList;

import javax.swing.ImageIcon;

/**
 * Represents a species in Darwin's World
 *
 * @author Brandyn Roemer Date: Mar 7, 2005 Time: 2:27:11 AM
 */
public class DWSpecies implements Serializable {


    /** asdf */
    public static final String TYPE_SOME = "some";

    /** asdf */
    public static final String TYPE_SHIP = "ship";

    /** asdf */
    public static final String TYPE_PACMAN = "pacman";

    /** asdf */
    public static final String TYPE_WIZARD = "wizard";




    /** The name of this species */
    private String speciesType;
    /** An icon representing this species */
    private ImageIcon icon;
    /** The script to use for controlling creatures of this species */
    private ArrayList /* DWLScript */ script;
    /** The species' wins. */
    private int wins;
    /** The species' losses. */
    private int losses;

    /**
     * Creates a new DWSpecies with no name, icon, or script
     */
    public DWSpecies() {
        this.speciesType = "unknown";
        this.icon = null;
        this.script = null;
    }




    /**
     * asdf
     *
     * @param species The species name
     */
    public DWSpecies(String species) {

        this.speciesType = species;
    }



    /**
     * Creates a new DWSpecies with the specified
     * name and icon, but with no script
     *
     * @param species The species name
     * @param icon The image icon
     */
    public DWSpecies(String species, ImageIcon icon) {

        this.speciesType = species;
        this.icon = icon;
    }

    /**
     * Creates a new DWSpecies with the specified name, icon and script
     *
     * @param species The species name
     * @param icon The image icon
     * @param script The script to use for controlling creatures of this species
     */
    public DWSpecies(String species, ImageIcon icon, ArrayList script) {
        this.speciesType = species;
        this.icon = icon;
        this.script = script;
    }

    /**
     * Gets the species name
     *
     * @return Species name
     */
    public String getSpeciesType() {
        return speciesType;
    }

    /**
     * Sets the species name
     *
     * @param species The species name
     */
    public void setSpeciesType(String species) {
        this.speciesType = species;
    }

    /**
     * Gets the icon for this species
     *
     * @return The icon
     */
    public ImageIcon getIcon() {
        return icon;
    }

    /**
     * Sets the icon for this species
     *
     * @param icon The icon to set
     */
    public void setIcon(ImageIcon icon) {
        this.icon = icon;
    }

    /**
     * Gets the script to use for controlling this edu.cs2335.lab7.creature
     *
     * @return The script
     */
    public ArrayList getScript() {
        return script;
    }

    /**
     * Sets the script to use for controlling this edu.cs2335.lab7.creature
     *
     * @param script The script to set
     */
    public void setScript(ArrayList script) {
        this.script = script;
    }

    /**
     * Test for whether two species type are the same
     * @param other The other species 
     * @return Whether they are the same or not
     */
    public boolean isequals(DWSpecies other) {
        return (this.speciesType.equals(other.getSpeciesType()));
    }

    /**
     * @return The number of wins the creature has.
     */
    public int getWins() {
        return wins;
    }

    /**
     * Increments the number of wins.
     */
    public void won() {
        wins++;
    }

    /**
     * @return The number of losses the creature has.
     */
    public int getLosses() {
        return losses;
    }

    /**
     * Increments the number of losses.
     */
    public void lost() {
        losses++;
    }

}

