
package edu.cs2335.lab7.data;

import java.io.Serializable;

import edu.cs2335.lab7.dwboard.DWBoard;

/**
 * @author thaile
 *
 * This object holds all the map infomation
 */
public class MapData implements Serializable {
    /** This name of the map */
    private final String name;
    /** The size of the map */
    private final int size;
    /** The board mask */
    private final DWBoard board;
    /** The info for rendering the map */
    private final MapImage mapImage;

    /**
     * Constructor for Map Data
     * @param name The name of the board
     * @param size The size of the board
     * @param board The board mask 
     * @param map The image data of the map
     */
    public MapData(String name, int size, DWBoard board, MapImage map) {
        this.name = name;
        this.size = size;
        this.board = board;
        this.mapImage = map;
    }
    
    /**
     * @return Returns the board.
     */
    public DWBoard getBoard() {
        return board;
    }
    /**
     * @return Returns the mapImage.
     */
    public MapImage getMapImage() {
        return mapImage;
    }
    
    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }
    /**
     * @return Returns the size.
     */
    public int getSize() {
        return size;
    }
}
