
package edu.cs2335.lab7.data;

import java.io.Serializable;

import javax.swing.ImageIcon;

/**
 * @author thaile
 *
 * used by the renderer to draw the map
 */
public class MapImage implements Serializable {
    /** The map */
    private final int[][] map;
    /** The tiles buffer */
    private final ImageIcon[] tiles;
    /** The north direction tile */
    private final ImageIcon dirTile;
    
    /**
     * Creates a map image for the map renderer
     * @param map The info on drawing the map
     * @param tiles the tiles to use
     * @param dirTile the tile for the north direction
     */
    public MapImage(int[][] map, ImageIcon[] tiles, ImageIcon dirTile) {
        this.map = map;
        this.tiles = tiles;
        this.dirTile = dirTile;
    }
    
    
    /**
     * @return Returns the map.
     */
    public int[][] getMap() {
        return map;
    }
    /**
     * @return Returns the tiles.
     */
    public ImageIcon[] getTiles() {
        return tiles;
    }
    
    /**
     * @return Returns the dirTile.
     */
    public ImageIcon getDirTile() {
        return dirTile;
    }
}
