package edu.cs2335.lab7.server;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;

/**
 * Darwin's World - CS2335 Lab7
 * @version 1.0
 * 
 * ShutdownServer - Controls the server shutdown. Connects to the server
 * socket on localhost and issues the EXIT command telling the server to quit.
 */
public class ShutdownServer {

    /** private constructor */
    private ShutdownServer() {
    }
    /**
     * Main method, executes server shutdown
     * @param args command line argument takes in the port number
     */
    public static void main(String[] args) {
        try {
        if (args.length < 1) {
            return;
        }       
        int port = Integer.parseInt(args[0]);
        Socket shutdownsocket = new Socket("localhost", port);
        PrintWriter output = new PrintWriter(shutdownsocket.getOutputStream());
        output.println("EXIT");
        output.close();
        shutdownsocket.close();
        } catch (IOException e) {
            return;
        }
    }
}
