package edu.cs2335.lab7.server;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.zip.ZipFile;

/**
 * Darwin's World - CS2335 Lab7
 * @version 1.0
 * 
 * User - Stores information relating to one user such as their
 * username, password, and stable of creatures.
 */
public class User implements Serializable {
    
    /**This user's username.*/
    private String username;
    
    /**The user's password.*/
    private String password;
    
    /**The user's status.*/
    private String status;
    
    /**The user's total wins.*/
    private int wins;

    /**The user's total losses.*/
    private int losses;

    /**List of species for this user.*/
    private List stable;
    
    /**
     * Constructor that creates a new user with the given username/password.
     * @param username  the username
     * @param password  the password
     */
    public User(String username, String password) {
        this.username = username;
        this.password = password;
        stable = new ArrayList();
        status = "offline";
    }
    
    /**
     * Adds a creature file to the player's stable.
     * @param creature  the creature to add
     */
    public synchronized void addToStable(ZipFile creature) {
        stable.add(creature);
    }

    /**
     * @return Returns the password.
     */
    public String getPassword() {
        return password;
    }
    
    /**
     * @param password The password to set.
     */
    public void setPassword(String password) {
        this.password = password;
    }
    
    /**
     * @return Returns the status.
     */
    public String getStatus() {
        return status;
    }
    
    /**
     * @param status The status to set.
     */
    public void setStatus(String status) {
        this.status = status;
    }
    
    /**
     * @return Returns the username.
     */
    public String getUsername() {
        return username;
    }
    /**
     * @return Returns the stable.
     */
    public List getStable() {
        return stable;
    }

    /**
     * @return The number of wins the user has.
     */
    public int getWins() {
        return wins;
    }

    /**
     * Increments the number of games won.
     */
    public void won() {
        wins++;
    }

    /**
     * @return The number of losses the user has.
     */
    public int getLosses() {
        return losses;
    }

    /**
     * Increments the number of games lost.
     */
    public void lost() {
        losses++;
    }
}
